package com.ekexiu.project.platform.company;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.Dynamic;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryOne;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2018/11/26.
 */
@DAO
public interface CompanyDao {

    @Insert
    int insert(Connection con, Company company) throws SQLException;

    @Update
    @Dynamic
    int update(Connection con, Company company) throws SQLException;

    @QueryOne
    @From(Company.class)
    @Nullable
    CompanyInfo query(Connection con, String id) throws SQLException;

    @SelectOne
    @Nullable
    Company queryByShareId(Connection con, long shareId) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<Company> pageQuery(Connection con, boolean actived, @Nullable @Like String name, int pageSize, int pageNo) throws SQLException;

    @Insert
    int insert(Connection con, CompKeyWord compKeyWord) throws SQLException;

    @DeleteWith
    @From(CompKeyWord.class)
    int deleteKeyWord(Connection con, String id) throws SQLException;

    @UpdateWith
    @From(Company.class)
    @SetSentence("INVITE_TIME = TO_CHAR(NOW(),'YYYYMMDDHH24MISS')")
    int invite(Connection con, String id) throws SQLException;

    @SelectList
    @From(CompKeyWord.class)
    List<CompKeyWord> queryKeyWord(Connection con, String id,@Nullable Integer type) throws SQLException;

    @Insert
    int insert(Connection con, CompInviteCode compInviteCode) throws SQLException;

    @SelectOne
    @Nullable
    CompInviteCode queryInviteCode(Connection con, String id) throws SQLException;
}
